"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ClinicalIndicationTest(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "clinicalIndicationTestTypeCode",
        "clinicalIndicationTestTypeId",
        "technology",
        "testTypeId",
        "testTypeName",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import participant as participant_1_5_0

        return {
            "technology": participant_1_5_0.Technology,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.Technology": participant_1_5_0.Technology,
            "org.gel.models.participant.avro.ClinicalIndicationTest": participant_1_5_0.ClinicalIndicationTest,
        }

    __slots__ = [
        "clinicalIndicationTestTypeCode",
        "clinicalIndicationTestTypeId",
        "technology",
        "testTypeId",
        "testTypeName",
    ]

    def __init__(
        self,
        clinicalIndicationTestTypeCode,
        clinicalIndicationTestTypeId,
        technology,
        testTypeId,
        testTypeName,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.ClinicalIndicationTest model.

        :param clinicalIndicationTestTypeCode:
            Clinical indication Test code (e.g. R13-1)
        :type clinicalIndicationTestTypeCode: str
        :param clinicalIndicationTestTypeId:
            Clinical indication Test type ID
        :type clinicalIndicationTestTypeId: str
        :param technology:
            Technology used in ClinicalIndicationTest
        :type technology: Technology
        :param testTypeId:
            Test Type Id
        :type testTypeId: str
        :param testTypeName:
            Test Type Name
        :type testTypeName: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
